<?php

namespace App\Http\Controllers\Admin\Board\Board;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Models\User;
use App\Models\Board;
use App\Models\BoardAdmin;
use Exception;

class ManagerController extends Controller
{
    private Board $boardModel;
    private BoardAdmin $boardAdminModel;
    private User $userModel;

    public function __construct(Board $board, BoardAdmin $boardAdmin, User $user)
    {
        $this->boardModel = $board;
        $this->boardAdminModel = $boardAdmin;
        $this->userModel = $user;
    }

    /**
     * 게시판 수정 - 관리자
     * @method GET
     * @see /admin/board/board/manager/{pk}
     */
    public function show(int $boardID)
    {
        return view('admin.board.board.manager', [
            'boardID' => $boardID,
            'actionURL' => route('admin.board.board.manager.store'),

            // 게시판 관리자 목록
            'boardAdminData' => $this->boardAdminModel->data(),

            // 게시판 정보
            'boardData' => $this->boardModel->find($boardID),

            // 모든 게시판
            'boardAllData' => $this->boardModel->all()
        ]);
    }

    /**
     * 게시판 그룹 관리자 등록 저장
     * @method POST
     * @see /admin/board/board/manager/{pk}
     */
    public function store(Request $request)
    {
        $rules = [
            'board_id' => 'required|numeric|exists:tb_board,id',
            'sid' => 'required|exists:users,sid'
        ];

        $attributes = [
            'board_id' => '게시판 수정 - 관리자',
            'sid' => '회원 ID'
        ];

        $posts = $this->validate($request, $rules, [], $attributes);

        $boardID = $posts['board_id'];
        $sid = $posts['sid'];

        $user = $this->userModel->findByUserID($sid);

        // 이미 등록된 관리자인지 확인
        $isBoardAdmin = $this->boardAdminModel->where([
            ['board_id', $boardID],
            ['user_id', $user->id]
        ])->count();

        if ($isBoardAdmin) {
            return back()->withErrors(['sid' => "{$sid}는 이미 등록된 관리자 입니다."])->withInput();
        }

        $this->boardAdminModel->insert([
            'board_id' => $boardID,
            'user_id' => $user->id,
            'created_at' => now()
        ]);

        $message = '게시판 관리자가 새로 등록되었습니다.';
        return redirect()->route('admin.board.board.manager.show', $boardID)->with('message', $message);
    }

    /**
     * 게시판 그룹 관리자 삭제
     * @method DELETE
     * @see /admin/board/board/manager/{pk}/destroy
     */
    public function destroy(Request $request)
    {
        try {

            $boardID = $request->post('board_id');
            $chk = $request->post('chk');

            if ($chk) {
                foreach ($chk as $boardAdminID) {
                    $boardAdmin = $this->boardAdminModel->findOrNew($boardAdminID);

                    if (!$boardAdmin->exists) {
                        throw new Exception($boardAdminID . '번 관리자는 존재하지 않습니다.');
                    }

                    if (!$boardAdmin->delete()) {
                        throw new Exception($boardAdminID . '번 관리자는 삭제할 수 없습니다.');
                    }
                }
            }

            $message = '게시판 관리자 정보가 삭제되었습니다.';
            return redirect()->route('admin.board.board.manager.show', $boardID)->with('message', $message);
        } catch (Exception $e) {
            return back()->withErrors($e->getMessage())->withInput();
        }
    }
}
